#! /usr/bin/env python3
# -*- coding: utf-8 -*-

#	Copyright 2011-2012, 2017, Marten de Vries
#	Copyright 2011, Milan Boers
#
#	This file is part of OpenTeacher.
#
#	OpenTeacher is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	OpenTeacher is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with OpenTeacher.  If not, see <http://www.gnu.org/licenses/>.

import json

class WordsHtmlGeneratorModule:
	def __init__(self, moduleManager, *args, **kwargs):
		super().__init__(*args, **kwargs)
		self._mm = moduleManager

		self.type = "htmlGenerator"
		self.dataType = "words"
		self.requires = (
			self._mm.mods(type="javaScriptEvaluator"),
		)

	def enable(self):
		modules = next(iter(self._mm.mods(type="modules")))
		try:
			self._js = modules.default("active", type="javaScriptEvaluator").loadModule('ot-html-generator-words')
		except FileNotFoundError:
			# module depends on the blueimp-tmpl, which is optional
			return
		self.active = True

	def disable(self):
		self.active = False

		del self._js

	def generate(self, lesson, margin=None, coloredRows=None):
		"""Generates a html document which provides an overview of all
		   the questions and answers in `lesson`. It includes an inline
		   stylesheet.

		   - `margin` specifies the margin for the page (should be valid
		     css, e.g. 1em or 1px)
		   - `coloredRows` specifies if the odd rows should have a
		     different background colors than the even ones.

		"""
		return self._js.global_["ot-html-generator-words"](lesson.list, margin=margin, coloredRows=coloredRows)

def init(moduleManager):
	return WordsHtmlGeneratorModule(moduleManager)
